<template>
  <div>
    <v-card flat width="450" height="550" class="login-card">
      <v-card-text>
        <div class="login-title">
          <h2>Cuidémonos</h2>
          <h3>Restablecer contraseña</h3>
          <p>Ingresa tu correo para restablecer tu contraseña</p>
        </div>
        <v-form ref="form" v-model="valid" class="my-8">
          <v-text-field
            label="Correo electrónico"
            v-model="email"
            :rules="emailRules"
            required
            outlined
          ></v-text-field>
        </v-form>
        <v-btn
          block
          height="50"
          rounded
          color="primary"
          @click="forgotPassword"
          :loading="loading"
          >Restablecer contraseña</v-btn
        >
        <v-btn
          text
          rounded
          block
          height="50"
          @click="$emit('change')"
          color="primary"
          class="mt-2"
        >
          Iniciar Sesión
        </v-btn>
      </v-card-text>
    </v-card>
    <default-dialog v-model="modal" :text="modalText" />
  </div>
</template>
<script>
import { mapActions, mapState } from "vuex";
import DefaultDialog from "@/components/Dialogs/DefaultDialog";

export default {
  data() {
    return {
      loading: false,
      valid: false,
      modal: false,
      modalText:
        "Te hemos enviado un correo con el enlace para restablecer tu contraseña",
      email: "",
      emailRules: [
        (v) => !!v || "El correo es requerido",
        (v) => /.+@.+\..+/.test(v) || "El correo debe ser válido",
      ],
    };
  },
  components: {
    DefaultDialog,
  },
  methods: {
    forgotPassword() {
      this.$refs.form.validate();
      const payload = { email: this.email };
      if (this.valid) {
        this.forgotPasswordState({ payload });
        this.modal = true;
      }
    },
    ...mapActions({
      forgotPasswordState: "auth/forgotPassword",
    }),
  },
};
</script>
<style scoped lang="scss">
.login-card {
  border-radius: 20px;
  padding: 0 20px;
  display: flex;
  align-items: center;
}
.login-title {
  margin-bottom: 40px;
  text-align: center;
  h2 {
    font-size: 35px;
    color: #1ecd96 !important;
    margin-bottom: 15px;
  }
  h3 {
    letter-spacing: 1.04px;
    margin-bottom: 15px;
  }
}
.forgot {
  cursor: pointer;
  text-align: right;
}
</style>
